diff --git a/src/include/storage/standbydefs.h b/src/include/storage/standbydefs.h
index 231d251fd51..c1053cbdf22 100644
--- a/src/include/storage/standbydefs.h
+++ b/src/include/storage/standbydefs.h
@@ -35,7 +35,7 @@ extern void standby_desc_invalidations(StringInfo buf,
 #define XLOG_RUNNING_XACTS			0x10
 #define XLOG_INVALIDATIONS			0x20
 
-typedef struct xl_standby_locks
+typedef struct PG_NO_PADDING xl_standby_locks
 {
 	int			nlocks;			/* number of entries in locks array */
 	xl_standby_lock locks[FLEXIBLE_ARRAY_MEMBER];
@@ -44,11 +44,13 @@ typedef struct xl_standby_locks
 /*
  * When we write running xact data to WAL, we use this structure.
  */
-typedef struct xl_running_xacts
+typedef struct PG_NO_PADDING xl_running_xacts
 {
 	int			xcnt;			/* # of xact ids in xids[] */
 	int			subxcnt;		/* # of subxact ids in xids[] */
 	bool		subxid_overflow;	/* snapshot overflowed, subxids missing */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	TransactionId nextXid;		/* xid from TransamVariables->nextXid */
 	TransactionId oldestRunningXid; /* *not* oldestXmin */
 	TransactionId latestCompletedXid;	/* so we can set xmax */
@@ -60,11 +62,13 @@ typedef struct xl_running_xacts
  * Invalidations for standby, currently only when transactions without an
  * assigned xid commit.
  */
-typedef struct xl_invalidations
+typedef struct PG_NO_PADDING xl_invalidations
 {
 	Oid			dbId;			/* MyDatabaseId */
 	Oid			tsId;			/* MyDatabaseTableSpace */
 	bool		relcacheInitFileInval;	/* invalidate relcache init files */
+	pg_padding_1(pg_pad1);
+	pg_padding_2(pg_pad2);
 	int			nmsgs;			/* number of shared inval msgs */
 	SharedInvalidationMessage msgs[FLEXIBLE_ARRAY_MEMBER];
 } xl_invalidations;
diff --git a/src/include/utils/relmapper.h b/src/include/utils/relmapper.h
index aa9226edac3..e60f495d5d4 100644
--- a/src/include/utils/relmapper.h
+++ b/src/include/utils/relmapper.h
@@ -24,7 +24,7 @@
 
 #define XLOG_RELMAP_UPDATE		0x00
 
-typedef struct xl_relmap_update
+typedef struct PG_NO_PADDING xl_relmap_update
 {
 	Oid			dbid;			/* database ID, or 0 for shared map */
 	Oid			tsid;			/* database's tablespace, or pg_global */
diff --git a/src/test/modules/test_custom_rmgrs/test_custom_rmgrs.c b/src/test/modules/test_custom_rmgrs/test_custom_rmgrs.c
index 6333661e437..2cd2ee0de14 100644
--- a/src/test/modules/test_custom_rmgrs/test_custom_rmgrs.c
+++ b/src/test/modules/test_custom_rmgrs/test_custom_rmgrs.c
@@ -29,7 +29,7 @@ PG_MODULE_MAGIC;
 /*
  * test_custom_rmgrs WAL record message.
  */
-typedef struct xl_testcustomrmgrs_message
+typedef struct PG_NO_PADDING xl_testcustomrmgrs_message
 {
 	Size		message_size;	/* size of the message */
 	char		message[FLEXIBLE_ARRAY_MEMBER]; /* payload */
diff --git a/src/test/recovery/t/039_end_of_wal.pl b/src/test/recovery/t/039_end_of_wal.pl
index f46d089a0fb..766e660988e 100644
--- a/src/test/recovery/t/039_end_of_wal.pl
+++ b/src/test/recovery/t/039_end_of_wal.pl
@@ -100,10 +100,11 @@ sub build_page_header
 	# I for xlp_tli
 	# II for xlp_pageaddr
 	# I for xlp_rem_len
-	return pack("SSIIII",
+	# I for pg_pad
+	return pack("SSIIIII",
 		$xlp_magic, $xlp_info, $xlp_tli,
 		$BIG_ENDIAN ? 0             : $xlp_pageaddr,
-		$BIG_ENDIAN ? $xlp_pageaddr : 0, $xlp_rem_len);
+		$BIG_ENDIAN ? $xlp_pageaddr : 0, $xlp_rem_len, 0);
 }
 
 # Setup a new node.  The configuration chosen here minimizes the number
-- 
2.43.0

